Option Explicit
'       MapInfo      
'        StdOut.
' :
' 1. tabPath -     Mapinfo (TAB - file)
'   2. coordsysStr -      .   ,    
'         MapInfo/MapBasic    ("),    ('),
'             VBScript,      :(" 
' 3. outTxt -    .   -  StdOut 
' 4. OverWriteFile -    [Yes]    [No].   - [No] ()
''        MapInfo
'
'	 :
'	mi_tabRasterReproject.vbs tabPath "coordsysStr" [OutFile] [OverWriteFile] 
'
'          Mapinfo 
'         TableInfo(). 
'          .
'     MapInfo      ,   ,
'      .

main
sub showHelp
dim helpStr
helpStr= "" & _
"        MapInfo      " & vbNewLine & _
"         StdOut." & vbNewLine & _
"   : " & vbNewLine & _
"      mi_tabRasterReproject.vbs tabPath coordsysStr [OutFile] [OverWriteFile]  " & vbNewLine & _
"  : " & vbNewLine & _
"   1. tabPath -     Mapinfo (TAB - file) " & vbNewLine & _
"   2. coordsysStr -      .   ,   " & vbNewLine & _
"         MapInfo/MapBasic   ,   ," & vbNewLine & _
"             VBScript,      :(" & vbNewLine & _
"   3. outFile -    .   -  StdOut " & vbNewLine & _
"   4. OverWriteFile -    [Yes] " & vbNewLine & _ 
"            [No].   - [No] () " & vbNewLine & _
"         MapInfo.  " & vbNewLine & _
"         Mapinfo." & vbNewLine & _
"          ." & vbNewLine & _
" " & vbNewLine

	    wscript.echo " " & WScript.ScriptName &  vbNewLine & _
		helpStr
end sub



'============================================================================
' MapInfo version 9.0 - System defines
'----------------------------------------------------------------------------
' This file contains defines useful when programming in the MapBasic
' language.  There are three versions of this file:
'     MAPBASIC.DEF  - MapBasic syntax
'     MAPBASIC.BAS  - Visual Basic syntax
'     MAPBASIC.H    - C/C++ syntax
'----------------------------------------------------------------------------
' The defines in this file are organized into the following sections:
'     General Purpose defines:
'       macros, logical constants, angle conversion, colors, string length
'     ButtonPadInfo() defines
'     ColumnInfo() and column type defines
'     CommandInfo() and task switch defines
'     DateWindow() defines
'     FileAttr() and file access mode defines
'     GetFolderPath$() defines
'     IntersectNodes() parameters
'     LabelInfo() defines
'     LayerInfo(), display mode, label property, layer type, hotlink defines
'     LegendInfo() and legend orientation defines
'     LegendFrameInfo() and frame type defines
'     LegendStyleInfo() defines
'     LocateFile$() defines
'     Map3DInfo() defines
'     MapperInfo(), display mode, calculation type, and clip type defines
'     MenuItemInfoByID() and MenuItemInfoByHandler() defines
'     ObjectGeography() defines
'     ObjectInfo() and object type defines
'     PrismMapInfo() defines
'     SearchInfo() defines
'     SelectionInfo() defines
'     Server statement and function defines
'     SessionInfo() defines
'     Set Next Document Style defines
'     StringCompare() return values
'     StyleAttr() defines
'     SystemInfo(), platform, and version defines
'     TableInfo() and table type defines
'     WindowInfo(), window type and state, and print orientation defines
'     Abbreviated list of error codes
'     Backward Compatibility defines
'============================================================================
' MAPBASIC.DEF is converted into MAPBASIC.H by doing the following:
'   - concatenate MAPBASIC.DEF and MENU.DEF into MAPBASIC.H
'   - search & replace "'" at begining of a line with "//"
'   - search & replace "Define" at begining of a line with "#define"
'   - delete the following sections:
'         * General Purpose defines:
'              Macros, Logical Constants, Angle Conversions
'         * Abbreviated list of error codes
'         * Backward Compatibility defines
'         * Menu constants whose names have changed
'         * Obsolete menu items
'============================================================================
' MAPBASIC.DEF is converted into MAPBASIC.BAS by doing the following:
'   - concatenate MAPBASIC.DEF and MENU.DEF into MAPBASIC.BAS
'   - search & replace "Define <name>" with "Const <name> ="
'     e.g. "<Define {[!-z]+} +{[!-z]}" with "Const \0 = \1" with Brief
'   - delete the following sections:
'         * General Purpose defines:
'             Macros, Logical Constants, Angle Conversions
'         * Abbreviated list of error codes
'         * Backward Compatibility defines
'         * Menu constants whose names have changed
'         * Obsolete menu items
'============================================================================

'============================================================================
' General Purpose defines
'============================================================================
'----------------------------------------------------------------------------
' Colors
'----------------------------------------------------------------------------
Const BLACK = 0
Const WHITE = 16777215
Const RED = 16711680
Const GREEN = 65280
Const BLUE = 255
Const CYAN = 65535
Const MAGENTA = 16711935
Const YELLOW = 16776960

'----------------------------------------------------------------------------
'Maximum length for character string
'----------------------------------------------------------------------------
Const MAX_STRING_LENGTH = 32767

'============================================================================
' ButtonPadInfo() defines
'============================================================================
Const BTNPAD_INFO_FLOATING = 1
Const BTNPAD_INFO_WIDTH = 2
Const BTNPAD_INFO_NBTNS = 3
Const BTNPAD_INFO_X = 4
Const BTNPAD_INFO_Y = 5
Const BTNPAD_INFO_WINID = 6

'============================================================================
' ColumnInfo() defines
'============================================================================
Const COL_INFO_NAME = 1
Const COL_INFO_NUM = 2
Const COL_INFO_TYPE = 3
Const COL_INFO_WIDTH = 4
Const COL_INFO_DECPLACES = 5
Const COL_INFO_INDEXED = 6
Const COL_INFO_EDITABLE = 7

'----------------------------------------------------------------------------
' Column type defines, returned by ColumnInfo() for COL_INFO_TYPE
'----------------------------------------------------------------------------
Const COL_TYPE_CHAR = 1
Const COL_TYPE_DECIMAL = 2
Const COL_TYPE_INTEGER = 3
Const COL_TYPE_SMALLINT = 4
Const COL_TYPE_DATE = 5
Const COL_TYPE_LOGICAL = 6
Const COL_TYPE_GRAPHIC = 7
Const COL_TYPE_FLOAT = 8
Const COL_TYPE_TIME = 37
Const COL_TYPE_DATETIME = 38

'============================================================================
' CommandInfo() defines
'============================================================================
Const CMD_INFO_X = 1
Const CMD_INFO_Y = 2
Const CMD_INFO_SHIFT = 3
Const CMD_INFO_CTRL = 4
Const CMD_INFO_X2 = 5
Const CMD_INFO_Y2 = 6
Const CMD_INFO_TOOLBTN = 7
Const CMD_INFO_MENUITEM = 8
Const CMD_INFO_WIN = 1
Const CMD_INFO_SELTYPE = 1
Const CMD_INFO_ROWID = 2
Const CMD_INFO_INTERRUPT = 3
Const CMD_INFO_STATUS = 1
Const CMD_INFO_MSG = 1000
Const CMD_INFO_DLG_OK = 1
Const CMD_INFO_DLG_DBL = 1
Const CMD_INFO_FIND_RC = 3
Const CMD_INFO_FIND_ROWID = 4
Const CMD_INFO_XCMD = 1
Const CMD_INFO_CUSTOM_OBJ = 1
Const CMD_INFO_TASK_SWITCH = 1
Const CMD_INFO_EDIT_TABLE = 1
Const CMD_INFO_EDIT_STATUS = 2
Const CMD_INFO_EDIT_ASK = 1
Const CMD_INFO_EDIT_SAVE = 2
Const CMD_INFO_EDIT_DISCARD = 3
Const CMD_INFO_HL_WINDOW_ID = 17
Const CMD_INFO_HL_TABLE_NAME = 18
Const CMD_INFO_HL_ROWID = 19
Const CMD_INFO_HL_LAYER_ID = 20
Const CMD_INFO_HL_FILE_NAME = 21

'----------------------------------------------------------------------------
' Task Switches, returned by CommandInfo() for CMD_INFO_TASK_SWITCH
'----------------------------------------------------------------------------
Const SWITCHING_OUT_OF_MAPINFO = 0
Const SWITCHING_INTO_MAPINFO = 1

'============================================================================
' DateWindow() defines
'============================================================================
Const DATE_WIN_SESSION = 1
Const DATE_WIN_CURPROG = 2

'============================================================================
' FileAttr() defines
'============================================================================
Const FILE_ATTR_MODE = 1
Const FILE_ATTR_FILESIZE = 2

'----------------------------------------------------------------------------
' File Access Modes, returned by FileAttr() for FILE_ATTR_MODE
'----------------------------------------------------------------------------
Const MODE_INPUT = 0
Const MODE_OUTPUT = 1
Const MODE_APPEND = 2
Const MODE_RANDOM = 3
Const MODE_BINARY = 4

'============================================================================
' GetFolderPath$() defines
'============================================================================

Const FOLDER_MI_APPDATA = -1
Const FOLDER_MI_LOCAL_APPDATA = -2
Const FOLDER_MI_PREFERENCE = -3
Const FOLDER_MI_COMMON_APPDATA = -4
Const FOLDER_APPDATA = 26
Const FOLDER_LOCAL_APPDATA = 28
Const FOLDER_COMMON_APPDATA = 35
Const FOLDER_COMMON_DOCS = 46
Const FOLDER_MYDOCS = 5
Const FOLDER_MYPICS = 39

'============================================================================
' IntersectNodes() defines
'============================================================================
Const INCL_CROSSINGS = 1
Const INCL_COMMON = 6
Const INCL_ALL = 7

'============================================================================
' LabelInfo() defines
'============================================================================
Const LABEL_INFO_OBJECT = 1
Const LABEL_INFO_POSITION = 2
Const LABEL_INFO_ANCHORX = 3
Const LABEL_INFO_ANCHORY = 4
Const LABEL_INFO_OFFSET = 5
Const LABEL_INFO_ROWID = 6
Const LABEL_INFO_TABLE = 7
Const LABEL_INFO_EDIT = 8
Const LABEL_INFO_EDIT_VISIBILITY = 9
Const LABEL_INFO_EDIT_ANCHOR = 10
Const LABEL_INFO_EDIT_OFFSET = 11
Const LABEL_INFO_EDIT_FONT = 12
Const LABEL_INFO_EDIT_PEN = 13
Const LABEL_INFO_EDIT_TEXT = 14
Const LABEL_INFO_EDIT_TEXTARROW = 15
Const LABEL_INFO_EDIT_ANGLE = 16
Const LABEL_INFO_EDIT_POSITION = 17
Const LABEL_INFO_EDIT_TEXTLINE = 18
Const LABEL_INFO_SELECT = 19
Const LABEL_INFO_DRAWN = 20
Const LABEL_INFO_ORIENTATION = 21

'============================================================================
' LayerInfo() defines
'============================================================================
Const LAYER_INFO_NAME = 1
Const LAYER_INFO_EDITABLE = 2
Const LAYER_INFO_SELECTABLE = 3
Const LAYER_INFO_ZOOM_LAYERED = 4
Const LAYER_INFO_ZOOM_MIN = 5
Const LAYER_INFO_ZOOM_MAX = 6
Const LAYER_INFO_COSMETIC = 7
Const LAYER_INFO_PATH = 8
Const LAYER_INFO_DISPLAY = 9
Const LAYER_INFO_OVR_LINE = 10
Const LAYER_INFO_OVR_PEN = 11
Const LAYER_INFO_OVR_BRUSH = 12
Const LAYER_INFO_OVR_SYMBOL = 13
Const LAYER_INFO_OVR_FONT = 14
Const LAYER_INFO_LBL_EXPR = 15
Const LAYER_INFO_LBL_LT = 16
Const LAYER_INFO_LBL_CURFONT = 17
Const LAYER_INFO_LBL_FONT = 18
Const LAYER_INFO_LBL_PARALLEL = 19
Const LAYER_INFO_LBL_POS = 20
Const LAYER_INFO_ARROWS = 21
Const LAYER_INFO_NODES = 22
Const LAYER_INFO_CENTROIDS = 23
Const LAYER_INFO_TYPE = 24
Const LAYER_INFO_LBL_VISIBILITY = 25
Const LAYER_INFO_LBL_ZOOM_MIN = 26
Const LAYER_INFO_LBL_ZOOM_MAX = 27
Const LAYER_INFO_LBL_AUTODISPLAY = 28
Const LAYER_INFO_LBL_OVERLAP = 29
Const LAYER_INFO_LBL_DUPLICATES = 30
Const LAYER_INFO_LBL_OFFSET = 31
Const LAYER_INFO_LBL_MAX = 32
Const LAYER_INFO_LBL_PARTIALSEGS = 33
Const LAYER_INFO_HOTLINK_EXPR = 34
Const LAYER_INFO_HOTLINK_MODE = 35
Const LAYER_INFO_HOTLINK_RELATIVE = 36
Const LAYER_INFO_HOTLINK_COUNT = 37
Const LAYER_INFO_LBL_ORIENTATION = 38

'----------------------------------------------------------------------------
' Values returned by LayerInfo() for LAYER_INFO_LABEL_ORIENTATION and
' LABEL_INFO_ORIENTATION.
'----------------------------------------------------------------------------
Const LAYER_INFO_LABEL_ORIENT_HORIZONTAL = 0
Const LAYER_INFO_LABEL_ORIENT_PARALLEL = 1
Const LAYER_INFO_LABEL_ORIENT_CURVED = 2

'----------------------------------------------------------------------------
' Display Modes, returned by LayerInfo() for LAYER_INFO_DISPLAY
'----------------------------------------------------------------------------
Const LAYER_INFO_DISPLAY_OFF = 0
Const LAYER_INFO_DISPLAY_GRAPHIC = 1
Const LAYER_INFO_DISPLAY_= 2
Const LAYER_INFO_DISPLAY_VALUE = 3

'----------------------------------------------------------------------------
' Label Linetypes, returned by LayerInfo() for LAYER_INFO_LBL_LT
'----------------------------------------------------------------------------
Const LAYER_INFO_LBL_LT_NONE = 0
Const LAYER_INFO_LBL_LT_SIMPLE = 1
Const LAYER_INFO_LBL_LT_ARROW = 2

'----------------------------------------------------------------------------
' Label Positions, returned by LayerInfo() for LAYER_INFO_LBL_POS
'----------------------------------------------------------------------------
Const LAYER_INFO_LBL_POS_CC = 0
Const LAYER_INFO_LBL_POS_TL = 1
Const LAYER_INFO_LBL_POS_TC = 2
Const LAYER_INFO_LBL_POS_TR = 3
Const LAYER_INFO_LBL_POS_CL = 4
Const LAYER_INFO_LBL_POS_CR = 5
Const LAYER_INFO_LBL_POS_BL = 6
Const LAYER_INFO_LBL_POS_BC = 7
Const LAYER_INFO_LBL_POS_BR = 8

'----------------------------------------------------------------------------
' Layer Types, returned by LayerInfo() for LAYER_INFO_TYPE
'----------------------------------------------------------------------------
Const LAYER_INFO_TYPE_NORMAL = 0
Const LAYER_INFO_TYPE_COSMETIC = 1
Const LAYER_INFO_TYPE_IMAGE = 2
Const LAYER_INFO_TYPE_THEMATIC = 3
Const LAYER_INFO_TYPE_GRID = 4
Const LAYER_INFO_TYPE_WMS = 5

'----------------------------------------------------------------------------
' Label visibility modes, from LayerInfo() for LAYER_INFO_LBL_VISIBILITY
'----------------------------------------------------------------------------
Const LAYER_INFO_LBL_VIS_OFF = 1
Const LAYER_INFO_LBL_VIS_ZOOM = 2
Const LAYER_INFO_LBL_VIS_ON = 3

'----------------------------------------------------------------------------
' HotlinkInfo() defines
'----------------------------------------------------------------------------
Const HOTLINK_INFO_EXPR = 1
Const HOTLINK_INFO_MODE = 2
Const HOTLINK_INFO_RELATIVE = 3
Const HOTLINK_INFO_ENABLED = 4

'----------------------------------------------------------------------------
' Hotlink activation modes, from LayerInfo() for LAYER_INFO_HOTLINK_MODE
'----------------------------------------------------------------------------
Const HOTLINK_MODE_LABEL = 0
Const HOTLINK_MODE_OBJ = 1
Const HOTLINK_MODE_BOTH = 2

'============================================================================
' LegendInfo() defines
'============================================================================
Const LEGEND_INFO_MAP_ID = 1
Const LEGEND_INFO_ORIENTATION = 2
Const LEGEND_INFO_NUM_FRAMES = 3
Const LEGEND_INFO_STYLE_SAMPLE_SIZE = 4

'============================================================================
' Orientation codes, returned by LegendInfo() for LEGEND_INFO_ORIENTATION
'============================================================================
Const ORIENTATION_PORTRAIT = 1
Const ORIENTATION_LANDSCAPE = 2
Const ORIENTATION_CUSTOM = 3

'----------------------------------------------------------------------------
' Style sample codes, from LegendInfo() for LEGEND_INFO_STYLE_SAMPLE_SIZE
'----------------------------------------------------------------------------
Const STYLE_SAMPLE_SIZE_SMALL = 0
Const STYLE_SAMPLE_SIZE_LARGE = 1

'============================================================================
' LegendFrameInfo() defines
'============================================================================
Const FRAME_INFO_TYPE = 1
Const FRAME_INFO_MAP_LAYER_ID = 2
Const FRAME_INFO_REFRESHABLE = 3
Const FRAME_INFO_POS_X = 4
Const FRAME_INFO_POS_Y = 5
Const FRAME_INFO_WIDTH = 6
Const FRAME_INFO_HEIGHT = 7
Const FRAME_INFO_TITLE = 8
Const FRAME_INFO_TITLE_FONT = 9
Const FRAME_INFO_SUBTITLE = 10
Const FRAME_INFO_SUBTITLE_FONT = 11
Const FRAME_INFO_BORDER_PEN = 12
Const FRAME_INFO_NUM_STYLES = 13
Const FRAME_INFO_VISIBLE = 14
Const FRAME_INFO_COLUMN = 15
Const FRAME_INFO_LABEL = 16

'============================================================================
' Frame Types, returned by LegendFrameInfo() for FRAME_INFO_TYPE
'============================================================================
Const FRAME_TYPE_STYLE = 1
Const FRAME_TYPE_THEME = 2

'============================================================================
' Geocode Attributes, returned by GeocodeInfo()
'============================================================================
Const GEOCODE_STREET_NAME = 1
Const GEOCODE_STREET_NUMBER = 2
Const GEOCODE_MUNICIPALITY = 3
Const GEOCODE_MUNICIPALITY2 = 4
Const GEOCODE_COUNTRY_SUBDIVISION = 5
Const GEOCODE_COUNTRY_SUBDIVISION2 = 6
Const GEOCODE_POSTAL_CODE = 7
Const GEOCODE_DICTIONARY = 9
Const GEOCODE_BATCH_SIZE = 10
Const GEOCODE_FALLBACK_GEOGRAPHIC = 11
Const GEOCODE_FALLBACK_POSTAL = 12
Const GEOCODE_OFFSET_CENTER = 13
Const GEOCODE_OFFSET_CENTER_UNITS = 14
Const GEOCODE_OFFSET_END = 15
Const GEOCODE_OFFSET_END_UNITS = 16
Const GEOCODE_MIXED_CASE = 17
Const GEOCODE_RESULT_MARK_MULTIPLE = 18
Const GEOCODE_COUNT_GEOCODED = 19
Const GEOCODE_COUNT_NOTGEOCODED = 20
Const GEOCODE_UNABLE_TO_CONVERT_DATA = 21
Const GEOCODE_MAX_BATCH_SIZE = 22

Const GEOCODE_PASSTHROUGH = 100

Const DICTIONARY_ALL = 1
Const DICTIONARY_ADDRESS_ONLY = 2
Const DICTIONARY_USER_ONLY = 3
Const DICTIONARY_PREFER_ADDRESS = 4
Const DICTIONARY_PREFER_USER = 5

'============================================================================
' ISOGRAM Attributes, returned by IsogramInfo()
'============================================================================
Const ISOGRAM_BANDING = 1
Const ISOGRAM_MAJOR_ROADS_ONLY = 2
Const ISOGRAM_RETURN_HOLES = 3
Const ISOGRAM_MAJOR_POLYGON_ONLY = 4
Const ISOGRAM_MAX_OFFROAD_DIST = 5
Const ISOGRAM_MAX_OFFROAD_DIST_UNITS = 6
Const ISOGRAM_SIMPLIFICATION_FACTOR = 7
Const ISOGRAM_DEFAULT_AMBIENT_SPEED = 8
Const ISOGRAM_AMBIENT_SPEED_DIST_UNIT = 9
Const ISOGRAM_AMBIENT_SPEED_TIME_UNIT = 10
Const ISOGRAM_PROPAGATION_FACTOR = 11
Const ISOGRAM_BATCH_SIZE = 12
Const ISOGRAM_POINTS_ONLY = 13
Const ISOGRAM_RECORDS_INSERTED = 14
Const ISOGRAM_RECORDS_NOTINSERTED = 15
Const ISOGRAM_MAX_BATCH_SIZE = 16
Const ISOGRAM_MAX_BANDS = 17
Const ISOGRAM_MAX_DISTANCE = 18
Const ISOGRAM_MAX_DISTANCE_UNITS = 19
Const ISOGRAM_MAX_TIME = 20
Const ISOGRAM_MAX_TIME_UNITS = 21

'============================================================================
' LegendStyleInfo() defines
'============================================================================
Const LEGEND_STYLE_INFO_TEXT = 1
Const LEGEND_STYLE_INFO_FONT = 2
Const LEGEND_STYLE_INFO_OBJ = 3

'============================================================================
' LocateFile$() defines
'============================================================================

Const LOCATE_PREF_FILE = 0
Const LOCATE_DEF_WOR = 1
Const LOCATE_CLR_FILE = 2
Const LOCATE_PEN_FILE = 3
Const LOCATE_FNT_FILE = 4
Const LOCATE_ABB_FILE = 5
Const LOCATE_PRJ_FILE = 6
Const LOCATE_MNU_FILE = 7
Const LOCATE_CUSTSYMB_DIR = 8
Const LOCATE_THMTMPLT_DIR = 9
Const LOCATE_GRAPH_DIR = 10
Const LOCATE_WMS_SERVERLIST = 11
Const LOCATE_WFS_SERVERLIST = 12
Const LOCATE_GEOCODE_SERVERLIST = 13
Const LOCATE_ROUTING_SERVERLIST = 14
Const LOCATE_LAYOUT_TEMPLATE_DIR = 15

'============================================================================
' Map3DInfo() defines
'============================================================================
Const MAP3D_INFO_SCALE = 1
Const MAP3D_INFO_RESOLUTION_X = 2
Const MAP3D_INFO_RESOLUTION_Y = 3
Const MAP3D_INFO_BACKGROUND = 4
Const MAP3D_INFO_UNITS = 5
Const MAP3D_INFO_LIGHT_X = 6
Const MAP3D_INFO_LIGHT_Y = 7
Const MAP3D_INFO_LIGHT_Z = 8
Const MAP3D_INFO_LIGHT_COLOR = 9
Const MAP3D_INFO_CAMERA_X = 10
Const MAP3D_INFO_CAMERA_Y = 11
Const MAP3D_INFO_CAMERA_Z = 12
Const MAP3D_INFO_CAMERA_FOCAL_X = 13
Const MAP3D_INFO_CAMERA_FOCAL_Y = 14
Const MAP3D_INFO_CAMERA_FOCAL_Z = 15
Const MAP3D_INFO_CAMERA_VU_1 = 16
Const MAP3D_INFO_CAMERA_VU_2 = 17
Const MAP3D_INFO_CAMERA_VU_3 = 18
Const MAP3D_INFO_CAMERA_VPN_1 = 19
Const MAP3D_INFO_CAMERA_VPN_2 = 20
Const MAP3D_INFO_CAMERA_VPN_3 = 21
Const MAP3D_INFO_CAMERA_CLIP_NEAR = 22
Const MAP3D_INFO_CAMERA_CLIP_FAR = 23

'============================================================================
' MapperInfo() defines
'============================================================================
Const MAPPER_INFO_ZOOM = 1
Const MAPPER_INFO_SCALE = 2
Const MAPPER_INFO_CENTERX = 3
Const MAPPER_INFO_CENTERY = 4
Const MAPPER_INFO_MINX = 5
Const MAPPER_INFO_MINY = 6
Const MAPPER_INFO_MAXX = 7
Const MAPPER_INFO_MAXY = 8
Const MAPPER_INFO_LAYERS = 9
Const MAPPER_INFO_EDIT_LAYER = 10
Const MAPPER_INFO_XYUNITS = 11
Const MAPPER_INFO_DISTUNITS = 12
Const MAPPER_INFO_AREAUNITS = 13
Const MAPPER_INFO_SCROLLBARS = 14
Const MAPPER_INFO_DISPLAY = 15
Const MAPPER_INFO_NUM_THEMATIC = 16
Const MAPPER_INFO_COORDSYS_CLAUSE = 17
Const MAPPER_INFO_COORDSYS_NAME = 18
Const MAPPER_INFO_MOVE_DUPLICATE_NODES = 19
Const MAPPER_INFO_DIST_CALC_TYPE = 20
Const MAPPER_INFO_DISPLAY_DMS = 21
Const MAPPER_INFO_COORDSYS_CLAUSE_WITH_BOUNDS = 22
Const MAPPER_INFO_CLIP_TYPE = 23
Const MAPPER_INFO_CLIP_REGION = 24
Const MAPPER_INFO_REPROJECTION = 25
Const MAPPER_INFO_RESAMPLING = 26
Const MAPPER_INFO_MERGE_MAP = 27

'----------------------------------------------------------------------------
' Display Modes, returned by MapperInfo() for MAPPER_INFO_DISPLAY_DMS
'----------------------------------------------------------------------------
Const MAPPER_INFO_DISPLAY_DECIMAL = 0
Const MAPPER_INFO_DISPLAY_DEGMINSEC = 1
Const MAPPER_INFO_DISPLAY_MGRS = 2

'----------------------------------------------------------------------------
' Display Modes, returned by MapperInfo() for MAPPER_INFO_DISPLAY
'----------------------------------------------------------------------------
Const MAPPER_INFO_DISPLAY_SCALE = 0
Const MAPPER_INFO_DISPLAY_ZOOM = 1
Const MAPPER_INFO_DISPLAY_POSITION = 2

'----------------------------------------------------------------------------
' Distance Calculation Types from MapperInfo() for MAPPER_INFO_DIST_CALC_TYPE
'----------------------------------------------------------------------------
Const MAPPER_INFO_DIST_SPHERICAL = 0
Const MAPPER_INFO_DIST_CARTESIAN = 1

'----------------------------------------------------------------------------
' Clip Types, returned by MapperInfo() for MAPPER_INFO_CLIP_TYPE
'----------------------------------------------------------------------------
Const MAPPER_INFO_CLIP_DISPLAY_ALL = 0
Const MAPPER_INFO_CLIP_DISPLAY_POLYOBJ = 1
Const MAPPER_INFO_CLIP_OVERLAY = 2

'============================================================================
' MenuItemInfoByID() and MenuItemInfoByHandler() defines
'============================================================================
Const MENUITEM_INFO_ENABLED = 1
Const MENUITEM_INFO_CHECKED = 2
Const MENUITEM_INFO_CHECKABLE = 3
Const MENUITEM_INFO_SHOWHIDEABLE = 4
Const MENUITEM_INFO_ACCELERATOR = 5
Const MENUITEM_INFO_TEXT = 6
Const MENUITEM_INFO_HELPMSG = 7
Const MENUITEM_INFO_HANDLER = 8
Const MENUITEM_INFO_ID = 9

'============================================================================
' ObjectGeography() defines
'============================================================================
Const OBJ_GEO_MINX = 1
Const OBJ_GEO_LINEBEGX = 1
Const OBJ_GEO_POINTX = 1
Const OBJ_GEO_MINY = 2
Const OBJ_GEO_LINEBEGY = 2
Const OBJ_GEO_POINTY = 2
Const OBJ_GEO_MAXX = 3
Const OBJ_GEO_LINEENDX = 3
Const OBJ_GEO_MAXY = 4
Const OBJ_GEO_LINEENDY = 4
Const OBJ_GEO_ARCBEGANGLE = 5
Const OBJ_GEO_TEXTLINEX = 5
Const OBJ_GEO_ROUNDRADIUS = 5
Const OBJ_GEO_CENTROID = 5
Const OBJ_GEO_ARCENDANGLE = 6
Const OBJ_GEO_TEXTLINEY = 6
Const OBJ_GEO_TEXTANGLE = 7
Const OBJ_GEO_POINTZ = 8
Const OBJ_GEO_POINTM = 9

'============================================================================
' ObjectInfo() defines
'============================================================================
Const OBJ_INFO_TYPE = 1
Const OBJ_INFO_PEN = 2
Const OBJ_INFO_SYMBOL = 2
Const OBJ_INFO_TEXTFONT = 2
Const OBJ_INFO_BRUSH = 3
Const OBJ_INFO_NPNTS = 20
Const OBJ_INFO_TEXTSTRING = 3
Const OBJ_INFO_SMOOTH = 4
Const OBJ_INFO_FRAMEWIN = 4
Const OBJ_INFO_NPOLYGONS = 21
Const OBJ_INFO_TEXTSPACING = 4
Const OBJ_INFO_TEXTJUSTIFY = 5
Const OBJ_INFO_FRAMETITLE = 6
Const OBJ_INFO_TEXTARROW = 6
Const OBJ_INFO_FILLFRAME = 7
Const OBJ_INFO_REGION = 8
Const OBJ_INFO_PLINE = 9
Const OBJ_INFO_MPOINT = 10
Const OBJ_INFO_NONEMPTY = 11
Const OBJ_INFO_Z_UNIT_SET = 12
Const OBJ_INFO_Z_UNIT = 13
Const OBJ_INFO_HAS_Z = 14
Const OBJ_INFO_HAS_M = 15

'----------------------------------------------------------------------------
' Object types, returned by ObjectInfo() for OBJ_INFO_TYPE
'----------------------------------------------------------------------------
Const OBJ_TYPE_ARC = 1
Const OBJ_TYPE_ELLIPSE = 2
Const OBJ_TYPE_LINE = 3
Const OBJ_TYPE_PLINE = 4
Const OBJ_TYPE_POINT = 5
Const OBJ_TYPE_FRAME = 6
Const OBJ_TYPE_REGION = 7
Const OBJ_TYPE_RECT = 8
Const OBJ_TYPE_ROUNDRECT = 9
Const OBJ_TYPE_TEXT = 10
Const OBJ_TYPE_MPOINT = 11
Const OBJ_TYPE_COLLECTION = 12

'============================================================================
' PrismMapInfo() defines
'============================================================================

Const PRISMMAP_INFO_SCALE = 1
Const PRISMMAP_INFO_BACKGROUND = 4
Const PRISMMAP_INFO_LIGHT_X = 6
Const PRISMMAP_INFO_LIGHT_Y = 7
Const PRISMMAP_INFO_LIGHT_Z = 8
Const PRISMMAP_INFO_LIGHT_COLOR = 9
Const PRISMMAP_INFO_CAMERA_X = 10
Const PRISMMAP_INFO_CAMERA_Y = 11
Const PRISMMAP_INFO_CAMERA_Z = 12
Const PRISMMAP_INFO_CAMERA_FOCAL_X = 13
Const PRISMMAP_INFO_CAMERA_FOCAL_Y = 14
Const PRISMMAP_INFO_CAMERA_FOCAL_Z = 15
Const PRISMMAP_INFO_CAMERA_VU_1 = 16
Const PRISMMAP_INFO_CAMERA_VU_2 = 17
Const PRISMMAP_INFO_CAMERA_VU_3 = 18
Const PRISMMAP_INFO_CAMERA_VPN_1 = 19
Const PRISMMAP_INFO_CAMERA_VPN_2 = 20
Const PRISMMAP_INFO_CAMERA_VPN_3 = 21
Const PRISMMAP_INFO_CAMERA_CLIP_NEAR = 22
Const PRISMMAP_INFO_CAMERA_CLIP_FAR = 23
Const PRISMMAP_INFO_INFOTIP_EXPR = 24

'============================================================================
' SearchInfo() defines
'============================================================================
Const SEARCH_INFO_TABLE = 1
Const SEARCH_INFO_ROW = 2

'============================================================================
' SelectionInfo() defines
'============================================================================
Const SEL_INFO_TABLENAME = 1
Const SEL_INFO_SELNAME = 2
Const SEL_INFO_NROWS = 3

'============================================================================
' Server statement and function defines
'============================================================================
'----------------------------------------------------------------------------
' Return Codes
'----------------------------------------------------------------------------
Const SRV_SUCCESS = 0
Const SRV_SUCCESS_WITH_INFO = 1
Const SRV_ERROR = -1
Const SRV_INVALID_HANDLE = -2
Const SRV_NEED_DATA = 99
Const SRV_NO_MORE_DATA = 100

'----------------------------------------------------------------------------
' Special values for the status associated with a fetched value
'----------------------------------------------------------------------------
Const SRV_NULL_DATA = -1
Const SRV_TRUNCATED_DATA = -2

'----------------------------------------------------------------------------
' Server_ColumnInfo() defines
'----------------------------------------------------------------------------
Const SRV_COL_INFO_NAME = 1
Const SRV_COL_INFO_TYPE = 2
Const SRV_COL_INFO_WIDTH = 3
Const SRV_COL_INFO_PRECISION = 4
Const SRV_COL_INFO_SCALE = 5
Const SRV_COL_INFO_VALUE = 6
Const SRV_COL_INFO_STATUS = 7
Const SRV_COL_INFO_ALIAS = 8

'----------------------------------------------------------------------------
' Column types, returned by Server_ColumnInfo() for SRV_COL_INFO_TYPE
'----------------------------------------------------------------------------
Const SRV_COL_TYPE_NONE = 0
Const SRV_COL_TYPE_CHAR = 1
Const SRV_COL_TYPE_DECIMAL = 2
Const SRV_COL_TYPE_INTEGER = 3
Const SRV_COL_TYPE_SMALLINT = 4
Const SRV_COL_TYPE_DATE = 5
Const SRV_COL_TYPE_LOGICAL = 6
Const SRV_COL_TYPE_FLOAT = 8
Const SRV_COL_TYPE_FIXED_LEN_STRING = 16
Const SRV_COL_TYPE_BIN_STRING = 17

'----------------------------------------------------------------------------
' Server_DriverInfo() Attr defines
'----------------------------------------------------------------------------
Const SRV_DRV_INFO_NAME = 1
Const SRV_DRV_INFO_NAME_LIST = 2
Const SRV_DRV_DATA_SOURCE = 3

'----------------------------------------------------------------------------
' Server_ConnectInfo() Attr defines
'----------------------------------------------------------------------------
Const SRV_CONNECT_INFO_DRIVER_NAME = 1
Const SRV_CONNECT_INFO_DB_NAME = 2
Const SRV_CONNECT_INFO_SQL_USER_ID = 3
Const SRV_CONNECT_INFO_DS_NAME = 4
Const SRV_CONNECT_INFO_QUOTE_CHAR = 5

'----------------------------------------------------------------------------
' Fetch Directions (used by ServerFetch function in some code libraries)
'----------------------------------------------------------------------------
Const SRV_FETCH_NEXT = -1
Const SRV_FETCH_PREV = -2
Const SRV_FETCH_FIRST = -3
Const SRV_FETCH_LAST = -4

'----------------------------------------------------------------------------
'Oracle workspace manager
'----------------------------------------------------------------------------
Const SRV_WM_HIST_NONE = 0
Const SRV_WM_HIST_OVERWRITE = 1
Const SRV_WM_HIST_NO_OVERWRITE = 2

'============================================================================
' SessionInfo() defines
'============================================================================

Const SESSION_INFO_COORDSYS_CLAUSE = 1
Const SESSION_INFO_DISTANCE_UNITS = 2
Const SESSION_INFO_AREA_UNITS = 3
Const SESSION_INFO_PAPER_UNITS = 4

'============================================================================
' Set Next Document Style defines
'============================================================================
Const WIN_STYLE_STANDARD = 0
Const WIN_STYLE_CHILD = 1
Const WIN_STYLE_POPUP_FULLCAPTION = 2
Const WIN_STYLE_POPUP = 3

'============================================================================
' StringCompare() defines
'============================================================================
Const STR_LT = -1
Const STR_GT = 1
Const STR_EQ = 0

'============================================================================
' StyleAttr() defines
'============================================================================
Const PEN_WIDTH = 1
Const PEN_PATTERN = 2
Const PEN_COLOR = 4
Const PEN_INDEX = 5
Const PEN_INTERLEAVED = 6
Const BRUSH_PATTERN = 1
Const BRUSH_FORECOLOR = 2
Const BRUSH_BACKCOLOR = 3
Const FONT_NAME = 1
Const FONT_STYLE = 2
Const FONT_POINTSIZE = 3
Const FONT_FORECOLOR = 4
Const FONT_BACKCOLOR = 5
Const SYMBOL_CODE = 1
Const SYMBOL_COLOR = 2
Const SYMBOL_POINTSIZE = 3
Const SYMBOL_ANGLE = 4
Const SYMBOL_FONT_NAME = 5
Const SYMBOL_FONT_STYLE = 6
Const SYMBOL_KIND = 7
Const SYMBOL_CUSTOM_NAME = 8
Const SYMBOL_CUSTOM_STYLE = 9

'----------------------------------------------------------------------------
' Symbol kinds returned by StyleAttr() for SYMBOL_KIND
'----------------------------------------------------------------------------
Const SYMBOL_KIND_VECTOR = 1
Const SYMBOL_KIND_FONT = 2
Const SYMBOL_KIND_CUSTOM = 3

'============================================================================
' SystemInfo() defines
'============================================================================
Const SYS_INFO_PLATFORM = 1
Const SYS_INFO_APPVERSION = 2
Const SYS_INFO_MIVERSION = 3
Const SYS_INFO_RUNTIME = 4
Const SYS_INFO_CHARSET = 5
Const SYS_INFO_COPYPROTECTED = 6
Const SYS_INFO_APPLICATIONWND = 7
Const SYS_INFO_DDESTATUS = 8
Const SYS_INFO_MAPINFOWND = 9
Const SYS_INFO_NUMBER_FORMAT = 10
Const SYS_INFO_DATE_FORMAT = 11
Const SYS_INFO_DIG_INSTALLED = 12
Const SYS_INFO_DIG_MODE = 13
Const SYS_INFO_MIPLATFORM = 14
Const SYS_INFO_MDICLIENTWND = 15
Const SYS_INFO_PRODUCTLEVEL = 16
Const SYS_INFO_APPIDISPATCH = 17

'----------------------------------------------------------------------------
' Platform, returned by SystemInfo() for SYS_INFO_PLATFORM
'----------------------------------------------------------------------------
Const PLATFORM_SPECIAL = 0
Const PLATFORM_WIN = 1
Const PLATFORM_MAC = 2
Const PLATFORM_MOTIF = 3
Const PLATFORM_X11 = 4
Const PLATFORM_XOL = 5

'----------------------------------------------------------------------------
' Version, returned by SystemInfo() for SYS_INFO_MIPLATFORM
'----------------------------------------------------------------------------
Const MIPLATFORM_SPECIAL = 0
Const MIPLATFORM_WIN16 = 1
Const MIPLATFORM_WIN32 = 2
Const MIPLATFORM_POWERMAC = 3
Const MIPLATFORM_MAC68K = 4
Const MIPLATFORM_HP = 5
Const MIPLATFORM_SUN = 6

'============================================================================
' TableInfo() defines
'============================================================================
Const TAB_INFO_NAME = 1
Const TAB_INFO_NUM = 2
Const TAB_INFO_TYPE = 3
Const TAB_INFO_NCOLS = 4
Const TAB_INFO_MAPPABLE = 5
Const TAB_INFO_READONLY = 6
Const TAB_INFO_TEMP = 7
Const TAB_INFO_NROWS = 8
Const TAB_INFO_EDITED = 9
Const TAB_INFO_FASTEDIT = 10
Const TAB_INFO_UNDO = 11
Const TAB_INFO_MAPPABLE_TABLE = 12
Const TAB_INFO_USERMAP = 13
Const TAB_INFO_USERBROWSE = 14
Const TAB_INFO_USERCLOSE = 15
Const TAB_INFO_USEREDITABLE = 16
Const TAB_INFO_USERREMOVEMAP = 17
Const TAB_INFO_USERDISPLAYMAP = 18
Const TAB_INFO_TABFILE = 19
Const TAB_INFO_MINX = 20
Const TAB_INFO_MINY = 21
Const TAB_INFO_MAXX = 22
Const TAB_INFO_MAXY = 23
Const TAB_INFO_SEAMLESS = 24
Const TAB_INFO_COORDSYS_MINX = 25
Const TAB_INFO_COORDSYS_MINY = 26
Const TAB_INFO_COORDSYS_MAXX = 27
Const TAB_INFO_COORDSYS_MAXY = 28
Const TAB_INFO_COORDSYS_CLAUSE = 29
Const TAB_INFO_COORDSYS_NAME = 30
Const TAB_INFO_NREFS = 31
Const TAB_INFO_SUPPORT_MZ = 32
Const TAB_INFO_Z_UNIT_SET = 33
Const TAB_INFO_Z_UNIT = 34
Const TAB_INFO_BROWSER_LIST = 35
Const TAB_INFO_THEME_METADATA = 36

'----------------------------------------------------------------------------
' Table type defines, returned by TableInfo() for TAB_INFO_TYPE
'----------------------------------------------------------------------------
Const TAB_TYPE_BASE = 1
Const TAB_TYPE_RESULT = 2
Const TAB_TYPE_VIEW = 3
Const TAB_TYPE_IMAGE = 4
Const TAB_TYPE_LINKED = 5
Const TAB_TYPE_WMS = 6
Const TAB_TYPE_WFS = 7
Const TAB_TYPE_FME = 8

'============================================================================
' WindowInfo() defines
'============================================================================
Const WIN_INFO_NAME = 1
Const WIN_INFO_TYPE = 3
Const WIN_INFO_WIDTH = 4
Const WIN_INFO_HEIGHT = 5
Const WIN_INFO_X = 6
Const WIN_INFO_Y = 7
Const WIN_INFO_TOPMOST = 8
Const WIN_INFO_STATE = 9
Const WIN_INFO_TABLE = 10
Const WIN_INFO_LEGENDS_MAP = 10
Const WIN_INFO_OPEN = 11
Const WIN_INFO_WND = 12
Const WIN_INFO_WINDOWID = 13
Const WIN_INFO_WORKSPACE = 14
Const WIN_INFO_CLONEWINDOW = 15
Const WIN_INFO_SYSMENUCLOSE = 16
Const WIN_INFO_AUTOSCROLL = 17
Const WIN_INFO_SMARTPAN = 18
Const WIN_INFO_SNAPMODE = 19
Const WIN_INFO_SNAPTHRESHOLD = 20
Const WIN_INFO_PRINTER_NAME = 21
Const WIN_INFO_PRINTER_ORIENT = 22
Const WIN_INFO_PRINTER_COPIES = 23
Const WIN_INFO_PRINTER_PAPERSIZE = 24
Const WIN_INFO_PRINTER_LEFTMARGIN = 25
Const WIN_INFO_PRINTER_RIGHTMARGIN = 26
Const WIN_INFO_PRINTER_TOPMARGIN = 27
Const WIN_INFO_PRINTER_BOTTOMMARGIN = 28
Const WIN_INFO_PRINTER_BORDER = 29
Const WIN_INFO_PRINTER_TRUECOLOR = 30
Const WIN_INFO_PRINTER_DITHER = 31
Const WIN_INFO_PRINTER_METHOD = 32
Const WIN_INFO_PRINTER_TRANSPRASTER = 33
Const WIN_INFO_PRINTER_TRANSPVECTOR = 34
Const WIN_INFO_EXPORT_BORDER = 35
Const WIN_INFO_EXPORT_TRUECOLOR = 36
Const WIN_INFO_EXPORT_DITHER = 37
Const WIN_INFO_EXPORT_TRANSPRASTER = 38
Const WIN_INFO_EXPORT_TRANSPVECTOR = 39
Const WIN_INFO_PRINTER_SCALE_PATTERNS = 40
Const WIN_INFO_EXPORT_ANTIALIASING = 41
Const WIN_INFO_EXPORT_THRESHOLD = 42
Const WIN_INFO_EXPORT_MASKSIZE = 43
Const WIN_INFO_EXPORT_FILTER = 44

'----------------------------------------------------------------------------
' Window types, returned by WindowInfo() for WIN_INFO_TYPE
'----------------------------------------------------------------------------
Const WIN_MAPPER = 1
Const WIN_BROWSER = 2
Const WIN_LAYOUT = 3
Const WIN_GRAPH = 4
Const WIN_BUTTONPAD = 19
Const WIN_TOOLBAR = 25
Const WIN_CART_LEGEND = 27
Const WIN_3DMAP = 28
Const WIN_HELP = 1001
Const WIN_MAPBASIC = 1002
Const WIN_MESSAGE = 1003
Const WIN_RULER = 1007
Const WIN_INFO = 1008
Const WIN_LEGEND = 1009
Const WIN_STATISTICS = 1010
Const WIN_MAPINFO = 1011
'----------------------------------------------------------------------------
' Version 2 window types no longer used in version 3 or later versions
'----------------------------------------------------------------------------
Const WIN_TOOLPICKER = 1004
Const WIN_PENPICKER = 1005
Const WIN_SYMBOLPICKER = 1006

'----------------------------------------------------------------------------
' Window states, returned by WindowInfo() for WIN_INFO_STATE
'----------------------------------------------------------------------------
Const WIN_STATE_NORMAL = 0
Const WIN_STATE_MINIMIZED = 1
Const WIN_STATE_MAXIMIZED = 2

'----------------------------------------------------------------------------
' Print orientation, returned by WindowInfo() for WIN_INFO_PRINTER_ORIENT
'----------------------------------------------------------------------------
Const WIN_PRINTER_PORTRAIT = 1
Const WIN_PRINTER_LANDSCAPE = 2

'----------------------------------------------------------------------------
' Antialiasing filters, returned by WindowInfo() for WIN_INFO_EXPORT_FILTER
'----------------------------------------------------------------------------
Const FILTER_VERTICALLY_AND_HORIZONTALLY = 0
Const FILTER_ALL_DIRECTIONS_1 = 1
Const FILTER_ALL_DIRECTIONS_2 = 2
Const FILTER_DIAGONALLY = 3
Const FILTER_HORIZONTALLY = 4
Const FILTER_VERTICALLY = 5

'============================================================================
' end of MAPBASIC.DEF
'============================================================================

'============================================================================
' MapInfo version 9.0 - Menu Item Definitions
'----------------------------------------------------------------------------
' This file contains defines useful when programming in the MapBasic
' language.  The definitions in this file describe the standard MapInfo
' functionality available via the "Run Menu Command" MapBasic statement.
'----------------------------------------------------------------------------
' The defines in this file are organized to match the sequence of
' declarations in the MAPINFOW.MNU file, which in turn reflects the
' organization of the MapInfo menus and buttonpads.
'============================================================================

'----------------------------------------------------------------------------
' File menu
'----------------------------------------------------------------------------
Const M_FILE_NEW = 101
Const M_FILE_OPEN = 102
Const M_FILE_OPEN_WMS = 118
Const M_FILE_OPEN_WFS = 119
Const M_FILE_OPEN_ODBC_CONN = 125
Const M_FILE_OPEN_UNIVERSAL_DATA = 126
Const M_FILE_CLOSE = 103
Const M_FILE_CLOSE_ALL = 104
Const M_FILE_CLOSE_ODBC = 124
Const M_FILE_SAVE = 105
Const M_FILE_SAVE_COPY_AS = 106
Const M_FILE_SAVE_QUERY = 117
Const M_FILE_SAVE_WORKSPACE = 109
Const M_FILE_SAVE_WINDOW_AS = 609
Const M_FILE_REVERT = 107
Const M_FILE_PAGE_SETUP = 111
Const M_FILE_PRINT = 112
Const M_FILE_EXIT = 113

'----------------------------------------------------------------------------
' Edit menu
'----------------------------------------------------------------------------
Const M_EDIT_UNDO = 201
Const M_EDIT_CUT = 202
Const M_EDIT_COPY = 203
Const M_EDIT_PASTE = 204
Const M_EDIT_CLEAR = 205
Const M_EDIT_CLEAROBJ = 206
Const M_EDIT_RESHAPE = 1601
Const M_EDIT_NEW_ROW = 702
Const M_EDIT_GETINFO = 207

'----------------------------------------------------------------------------
' Tools menu
'----------------------------------------------------------------------------
Const M_TOOLS_CRYSTAL_REPORTS_NEW = 1802
Const M_TOOLS_CRYSTAL_REPORTS_OPEN = 1803
Const M_TOOLS_RUN = 110
Const M_TOOLS_TOOL_MANAGER = 1801

'----------------------------------------------------------------------------
' Objects menu
'----------------------------------------------------------------------------
Const M_OBJECTS_SET_TARGET = 1610
Const M_OBJECTS_CLEAR_TARGET = 1611
Const M_OBJECTS_COMBINE = 1605
Const M_OBJECTS_DISAGG = 1621
Const M_OBJECTS_BUFFER = 1606
Const M_OBJECTS_CONVEX_HULL = 1616
Const M_OBJECTS_ENCLOSE = 1617
Const M_OBJECTS_VORONOI = 1622
Const M_OBJECTS_SPLIT = 1612
Const M_OBJECTS_ERASE = 1613
Const M_OBJECTS_ERASE_OUT = 1614
Const M_OBJECTS_POLYLINE_SPLIT = 1623
Const M_OBJECTS_POLYLINE_SPLIT_AT_NODE = 1626
Const M_OBJECTS_DRIVE_REGION = 1627
Const M_OBJECTS_OVERLAY = 1615
Const M_OBJECTS_CHECK_REGIONS = 1618
Const M_OBJECTS_CLEAN = 1619
Const M_OBJECTS_SNAP = 1620
Const M_OBJECTS_OFFSET = 1624
Const M_OBJECTS_ROTATE = 1625
Const M_OBJECTS_SMOOTH = 1602
Const M_OBJECTS_UNSMOOTH = 1603
Const M_OBJECTS_CVT_PGON = 1607
Const M_OBJECTS_CVT_PLINE = 1604

'----------------------------------------------------------------------------
' Query menu
'----------------------------------------------------------------------------
Const M_QUERY_SELECT = 301
Const M_QUERY_SQLQUERY = 302
Const M_QUERY_SELECTALL = 303
Const M_QUERY_INVERTSELECT = 311
Const M_QUERY_UNSELECT = 304
Const M_QUERY_FIND = 305
Const M_QUERY_FIND_SELECTION = 306
Const M_QUERY_CALC_STATISTICS = 309
Const M_QUERY_FIND_SELECTION_CURRENT_MAP = 312
Const M_QUERY_FIND_ADDRESS = 313

'----------------------------------------------------------------------------
' Table, Maintenance, and Raster menus
'----------------------------------------------------------------------------
Const M_TABLE_UPDATE_COLUMN = 405
Const M_TABLE_APPEND = 411
Const M_TABLE_GEOCODE = 407
Const M_TABLE_CREATE_POINTS = 408
Const M_TABLE_MERGE_USING_COLUMN = 406
Const M_TABLE_BUFFER = 419
Const M_TABLE_VORONOI = 420
Const M_TABLE_IMPORT = 401
Const M_TABLE_EXPORT = 402

Const M_TABLE_MODIFY_STRUCTURE = 404
Const M_TABLE_DELETE = 409
Const M_TABLE_RENAME = 410
Const M_TABLE_PACK = 403
Const M_TABLE_MAKEMAPPABLE = 415
Const M_TABLE_CHANGESYMBOL = 418
Const M_TABLE_UNLINK = 416
Const M_TABLE_REFRESH = 417

Const M_TABLE_RASTER_STYLE = 414
Const M_TABLE_RASTER_REG = 413
Const M_TOOLS_RASTER_REG = 1730
Const M_TABLE_WMS_PROPS = 421
Const M_TABLE_WFS_REFRESH = 422
Const M_TABLE_WFS_PROPS = 423
Const M_TABLE_WEB_GEOCODE = 424
Const M_TABLE_DRIVE_REGION = 425
Const M_TABLE_UNIVERSAL_DATA_REFRESH = 426

Const M_ORACLE_CREATE_WORKSPACE = 1804
Const M_ORACLE_DELETE_WORKSPACE = 1805
Const M_ORACLE_VERSION_ENABLE_ON = 1806
Const M_ORACLE_VERSION_ENABLE_OFF = 1807
Const M_ORACLE_MERGE_PARENT = 1808
Const M_ORACLE_REFRESH_FROM_PARENT = 1809

'----------------------------------------------------------------------------
' Options and Preferences menus
'----------------------------------------------------------------------------
Const M_FORMAT_PICK_LINE = 501
Const M_FORMAT_PICK_FILL = 502
Const M_FORMAT_PICK_SYMBOL = 503
Const M_FORMAT_PICK_FONT = 504
Const M_WINDOW_BUTTONPAD = 605
Const M_WINDOW_LEGEND = 606
Const M_WINDOW_STATISTICS = 607
Const M_WINDOW_MAPBASIC = 608
Const M_WINDOW_STATUSBAR = 616
Const M_FORMAT_CUSTOM_COLORS = 617
Const M_EDIT_PREFERENCES = 208

Const M_EDIT_PREFERENCES_SYSTEM = 210
Const M_EDIT_PREFERENCES_MAP = 212
Const M_EDIT_PREFERENCES_LEGEND = 215
Const M_EDIT_PREFERENCES_FILE = 211
Const M_EDIT_PREFERENCES_COUNTRY = 213
Const M_EDIT_PREFERENCES_PATH = 214
Const M_EDIT_PREFERENCES_OUTPUT = 216
Const M_EDIT_PREFERENCES_PRINTER = 217
Const M_EDIT_PREFERENCES_STYLES = 218
Const M_EDIT_PREFERENCES_IMAGE_PROC = 219
Const M_EDIT_PREFERENCES_WEBSERVICES = 220
Const M_EDIT_PREFERENCES_LAYOUT = 221

'----------------------------------------------------------------------------
' Window menu
'----------------------------------------------------------------------------
Const M_WINDOW_BROWSE = 601
Const M_WINDOW_MAP = 602
Const M_WINDOW_GRAPH = 603
Const M_WINDOW_LAYOUT = 604
Const M_WINDOW_REDISTRICT = 615
Const M_WINDOW_REDRAW = 610
Const M_WINDOW_TILE = 611
Const M_WINDOW_CASCADE = 612
Const M_WINDOW_ARRANGEICONS = 613
Const M_WINDOW_MORE = 614
Const M_WINDOW_FIRST = 620
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
' Note: the 2nd through 80th windows can be accessed as (M_WINDOW_FIRST+i-1)
' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

'----------------------------------------------------------------------------
' Help menu
'----------------------------------------------------------------------------
Const M_HELP_CONTEXTSENSITIVE = 1201
Const M_HELP_CONTENTS = 1202
Const M_HELP_SEARCH = 1203
Const M_HELP_USE_HELP = 1204
Const M_HELP_ABOUT = 1205
Const M_HELP_HELPMODE = 1206
Const M_HELP_TECHSUPPORT = 1208
Const M_HELP_CONNECT_MIFORUM = 1209
Const M_HELP_MAPINFO_WWW = 1210
Const M_HELP_MAPINFO_WWW_STORE = 1211
Const M_HELP_CHECK_FOR_UPDATE = 1212
Const M_HELP_MAPINFO_WWW_TUTORIAL = 1213
Const M_HELP_MAPINFO_3DGRAPH_HELP = 1214
Const M_HELP_MAPINFO_CONNECT_SERVICES = 1215

'----------------------------------------------------------------------------
' Browse menu
'----------------------------------------------------------------------------
Const M_BROWSE_PICK_FIELDS = 704
Const M_BROWSE_OPTIONS = 703

'----------------------------------------------------------------------------
' Map menu
'----------------------------------------------------------------------------
Const M_MAP_LAYER_CONTROL = 801
Const M_MAP_CREATE_3DMAP = 817
Const M_MAP_CREATE_PRISMMAP = 818
Const M_MAP_THEMATIC = 307
Const M_MAP_MODIFY_THEMATIC = 308
Const M_MAP_CREATE_LEGEND = 816
Const M_MAP_CHANGE_VIEW = 805
Const M_MAP_CLONE_MAPPER = 811
Const M_MAP_PREVIOUS = 806
Const M_MAP_ENTIRE_LAYER = 807
Const M_MAP_CLEAR_CUSTOM_LABELS = 814
Const M_MAP_SAVE_COSMETIC = 809
Const M_MAP_CLEAR_COSMETIC = 810
Const M_MAP_SET_CLIP_REGION = 812
Const M_MAP_CLIP_REGION_ONOFF = 813
Const M_MAP_SETUPDIGITIZER = 803
Const M_MAP_OPTIONS = 802

'----------------------------------------------------------------------------
' Layout menu
'----------------------------------------------------------------------------
Const M_LAYOUT_CHANGE_VIEW = 902
Const M_LAYOUT_ACTUAL = 903
Const M_LAYOUT_ENTIRE = 904
Const M_LAYOUT_PREVIOUS = 905
Const M_LAYOUT_BRING2FRONT = 906
Const M_LAYOUT_SEND2BACK = 907
Const M_LAYOUT_ALIGN = 908
Const M_LAYOUT_DROPSHADOWS = 909
Const M_LAYOUT_DISPLAYOPTIONS = 901
Const M_LAYOUT_AUTOSCROLL_ONOFF = 910

'----------------------------------------------------------------------------
' Graph menu
'----------------------------------------------------------------------------
Const M_GRAPH_TYPE = 1001
Const M_GRAPH_LABEL_AXIS = 1002
Const M_GRAPH_VALUE_AXIS = 1003
Const M_GRAPH_SERIES = 1004

'----------------------------------------------------------------------------
' New Graph menu
'----------------------------------------------------------------------------
Const M_GRAPH_FORMATING = 2007
Const M_GRAPH_GENERAL_OPTIONS = 2002
Const M_GRAPH_SERIES_OPTIONS = 2003
Const M_GRAPH_GRID_SCALES = 2004
Const M_GRAPH_TITLES = 2005
Const M_GRAPH_3D_VIEWING_ANGLE = 2006
Const M_GRAPH_SAVE_AS_TEMPLATE = 2008

'----------------------------------------------------------------------------
' MapBasic menu
'----------------------------------------------------------------------------
Const M_MAPBASIC_CLEAR = 1101
Const M_MAPBASIC_SAVECONTENTS = 1102

'----------------------------------------------------------------------------
' Redistrict menu
'----------------------------------------------------------------------------
Const M_REDISTRICT_ASSIGN = 705
Const M_REDISTRICT_TARGET = 706
Const M_REDISTRICT_ADD = 707
Const M_REDISTRICT_DELETE = 708
Const M_REDISTRICT_OPTIONS = 709

'----------------------------------------------------------------------------
' Legend menu
'----------------------------------------------------------------------------
Const M_LEGEND_PROPERTIES = 1901
Const M_LEGEND_REFRESH = 1902
Const M_LEGEND_ADD_FRAMES = 1903
Const M_LEGEND_DELETE = 1904

'----------------------------------------------------------------------------
' 3DMap menu
'----------------------------------------------------------------------------
Const M_3DMAP_VIEW_ENTIRE_GRID = 2101
Const M_3DMAP_PROPERTIES = 2102
Const M_3DMAP_REFRESH_GRID_TEXTURE = 2103
Const M_3DMAP_WIREFRAME = 2104
Const M_3DMAP_CLONE_VIEW = 2105
Const M_3DMAP_PREVIOUS_VIEW = 2106
Const M_3DMAP_VIEWPOINT_CONTROL = 2107

'----------------------------------------------------------------------------
' Main Buttonpad
'----------------------------------------------------------------------------
Const M_TOOLS_SELECTOR = 1701
Const M_TOOLS_SEARCH_RECT = 1722
Const M_TOOLS_SEARCH_RADIUS = 1703
Const M_TOOLS_SEARCH_BOUNDARY = 1704
Const M_TOOLS_EXPAND = 1705
Const M_TOOLS_SHRINK = 1706
Const M_TOOLS_RECENTER = 1702
Const M_TOOLS_PNT_QUERY = 1707
Const M_TOOLS_HOTLINK = 1736
Const M_TOOLS_LABELER = 1708
Const M_TOOLS_DRAGWINDOW = 1734
Const M_TOOLS_RULER = 1710

'----------------------------------------------------------------------------
' Drawing Buttonpad
'----------------------------------------------------------------------------
Const M_TOOLS_POINT = 1711
Const M_TOOLS_LINE = 1712
Const M_TOOLS_POLYLINE = 1713
Const M_TOOLS_ARC = 1716
Const M_TOOLS_POLYGON = 1714
Const M_TOOLS_ELLIPSE = 1715
Const M_TOOLS_RECTANGLE = 1717
Const M_TOOLS_ROUNDEDRECT = 1718
Const M_TOOLS_TEXT = 1709
Const M_TOOLS_FRAME = 1719
Const M_TOOLS_ADD_NODE = 1723

'----------------------------------------------------------------------------
' DBMS Buttonpad
'  -- most DBMS buttons defined under M_TABLE_{...} except for this one:
'----------------------------------------------------------------------------
Const M_DBMS_OPEN_ODBC = 116

'----------------------------------------------------------------------------
' Menu and ButtonPad items that do not appear in the standard menus
'----------------------------------------------------------------------------
Const M_TOOLS_MAPBASIC = 1720
Const M_TOOLS_SEARCH_POLYGON = 1733

'============================================================================
' end of MENU.DEF
'============================================================================

'============================================================================
' FileSystemObject constants
'============================================================================
const ForReading =  1 ' Open a file for reading only. You can't write to this file.
const ForWriting =  2 ' Open a file for writing.
const ForAppending= 8 ' Open a file and write to the end of the file.


sub main
	dim i,j,k,L,M,N,t,s,v,vParams
	
    dim FSO
	Dim outFile,inFile
    dim miCmd
	dim miObj
	dim tabPath
	dim outTxt, outPath
	dim OverWriteFile
	dim oldCoordsysStr, newCoordSysStr
	dim iResCode
	Dim WshShell : Set WshShell = WScript.CreateObject("WScript.Shell")
	 
	Dim oArgs : Set oArgs = Wscript.Arguments
	if oArgs.count > 4 or oArgs.count < 2 then
		showHelp
	    wscript.quit(-99999)
	end if
	iResCode=-9999
	N=0

	tabPath=oArgs(0)
	newCoordSysStr=oArgs(1)
	newCoordSysStr=replace(newCoordSysStr,"'","""") '' ! VBScript       
			' !  ,        ,    
			'   (')
	

	Set fso = CreateObject("Scripting.FileSystemObject")
	tabPath=fso.GetAbsolutePathName(tabPath)
	if not fso.FileExists(tabPath) then
		wscript.echo "TAB File not found:"  & vbnewline & tabPath
	    wscript.quit(-99998)
	end if

	Set outFile = Nothing
	if oArgs.count > 2 then
		outPath=oArgs(2)
		OverWriteFile=False
		if oArgs.count = 4 then
			OverWriteFile = (Ucase(oArgs(3))="YES")
		end if
	end if

	on error resume next
	Set miObj = Nothing
    Set miObj = GetObject(,"MapInfo.Application")
	on error goto 0
	if miObj is nothing then
		wscript.echo "No Active MapInfo or connection Failed."  & vbnewline & _
			"Start MapInfo before using this script."
	    wscript.quit(-80001)
	end if
	
	
	s=miObj.Eval( "SystemInfo(" & SYS_INFO_PLATFORM & ")") '' DEBUG Only
    '' MsgBox s '' DEBUG Only
	s=vbNullString
    on error resume next
	s=miObj.Eval( "2*2")
	on error goto 0
	if s <> "4" then
		wscript.echo "No Active MapInfo or connection Failed."  & vbnewline & _
			"MapInfo are to be started before using this script."
	    wscript.quit(-80002)
	end if
	
	''        
	'' 
	N=0
	L=0
	Set inFile = fso.OpenTextFile(tabPath,ForReading)
	dim myArr, cSp
	cSp=Chr(255)
	t=inFile.ReadAll
	inFile.Close
	'' wscript.echo t
	t=replace(t,vbnewline,cSp)
	myArr=Split(t,cSp)

	L=len(t)
	if L < 4 then
			wscript.echo "A* This file not Mapinfo TAB raster file:" & vbnewline & tabPath
			wscript.quit(-90002)
	end if
	N= Ubound(myArr)
	if N < 5 then
			wscript.echo "B* This file not Mapinfo TAB raster file:" & vbnewline & tabPath
			wscript.quit(-90002)
	end if
	
	if lcase(myArr(0)) <> "!table" then
			wscript.echo "C* This file not Mapinfo TAB raster file:" & vbnewline & tabPath
			wscript.quit(-90002)
	end if
	M=-1
	N=N-1
	for i=1 to N
		'' wscript.echo cstr(i) & " : " & myArr(i)
		t=UCase(trim(myArr(i)))
		if instr(t,"TYPE ""RASTER""") > 0 then
			M=i
			'' msgbox "M=" & M
			exit for
		end if
	next
	if M < 0 then
			wscript.echo "D* This file not Mapinfo TAB raster file:" & vbnewline & tabPath
			wscript.quit(-90002)
	end if

	L=-1
	oldCoordsysStr=vbnewLine
	M=M+1
	'' msgbox "M=" & M
	for i=M to N
		t=trim(myArr(i))
		'' wscript.echo cstr(i) & " : " & t
		if len(t) > 0 Then
			if Left(t,1) <> "!" then
				if left(t,1) = "(" then
					L=i
					myArr(i)=t
				else
					t=LCase(t)
					if instr(t,"coordsys ") > 0 then
						oldCoordsysStr=myArr(i)
						myArr(i)="!" & myArr(i) & vbnewLine & newCoordSysStr
					elseif instr(t,"units ") > 0 then
						''       ,   
						'' Units "degree"  , ..    MapInfo   
						''       
						myArr(i)=vbNullString
					end if
				end if
			end if
		end if
	next
	'' msgbox "M,L,i=" & M & ", " & L & ", " & i & vbnewline & oldCoordsysStr & vbnewline & newCoordSysStr
	if L < 0 then 
			wscript.echo "* This file not Mapinfo TAB raster file:" & vbnewline & tabPath
			wscript.quit(-90002)
	end if
	if L-M < 2 then 
			wscript.echo "* This Mapinfo TAB not valid raster file:" & vbnewline & tabPath
			wscript.quit(-90003)
	end if
	if len(oldCoordsysStr) = 0 then
		oldCoordsysStr="CoordSys Earth Projection 1, 0" ''   MI  
	end if
	'' msgbox "M,L,i=" & M & ", " & L & ", " & i 
	dim i1,i2
	i1=(instr(lcase(oldCoordsysStr),"nonearth") > 0)
	i2=(instr(lcase(newCoordSysStr),"nonearth") > 0)
	if (i1 Xor i2) then
			wscript.echo "* No valid convertion between 'Earth' and 'NonEarth' CoordSys :" & vbnewline & _
				"  ---> " & oldCoordsysStr & vbnewline &  _
				"  <--- " & newCoordSysStr
			wscript.quit(-90004)
	end if
	
	i2=L-M
	'' msgbox "M,L,i2 =" & M & ", " & L & ", " & i2 
	
	dim x(),y()
	ReDim x(i2)
	ReDim y(i2)
	
	for i=M to L
		'' wscript.echo cstr(i) & " : " & myArr(i)
		t=myarr(i)
		j=instr(t,"(")
		if j=0 then
			wscript.echo "* This Mapinfo TAB not valid raster file:" & vbnewline & tabPath
			wscript.quit(-90003)
		end if
		j=j+1
		i2=instr(j,t,",")
		if i2=0 then
			wscript.echo "* This Mapinfo TAB not valid raster file:" & vbnewline & tabPath
			wscript.quit(-90003)
		end if
		x(i-M)=mid(t,j,i2-j)
		j=i2+1
		i2=instr(j,t,")")
		if i2=0 then
			wscript.echo "* This Mapinfo TAB not valid raster file:" & vbnewline & tabPath
			wscript.quit(-90003)
		end if
		'' wscript.echo mid(t,j,i2-j)
		y(i-M)=mid(t,j,i2-j)
		'' wscript.echo x(i-M)  & " , " & y(i-M)
		myarr(i)=mid(t,i2+1)
		'' wscript.echo x(i-M)  & " , " & y(i-M) & " " & myarr(i)
	next 

	''    Object  Mapinfo
	dim miVar
	miVar = "obj" & replace(fso.GetTempName,".","_")
	'' wscript.echo miVar
	miCmd="Dim " & miVar & " as Object "
	miObj.Do(miCmd)

	for i=M to L
		miCmd="Set " & oldCoordsysStr & " "
		miObj.Do(miCmd)
		miCmd=miVar & " = CreatePoint(" & x(i-M) & ", " & y(i-M) & ") "
		'' wscript.echo miCmd '' DEBUG Only
		miObj.Do(miCmd)
		miCmd="Set " & newCoordSysStr & " "
		'' wscript.echo miCmd '' DEBUG Only
		miObj.Do(miCmd)

		'' DEBUG Only
		t=miObj.Eval("Format$( ObjectGeography(" & miVar & ",  " & OBJ_GEO_MINX &  "), ""#.############"") ") 
		t=t & ", " & miObj.Eval("Format$( ObjectGeography(" & miVar & ",  " & OBJ_GEO_MINY &  "), ""#.############"") ")
		myArr(i)="   (" & t & ")" & myArr(i)
		'' wscript.echo myArr(i) '' DEBUG Only
	next 
	miCmd="unDim " & miVar & " "
	miObj.Do(miCmd)
	set miObj=Nothing
	
	L=UBound(myArr)
	t=vbNullString
	t=myArr(0)
	for i=1 to L
		t=t & vbNewLine & myArr(i) 
		'' wscript.echo myArr(i) '' DEBUG Only
	next 
	
	
    '' wscript.echo t '' DEBUG Only
	'' wscript.echo "// -----------------------" '' DEBUG Only

	Dim StdOut
	set outFile=Nothing
	if len(outPath) then
		if fso.FileExists(outPath) then
			if not OverWriteFile then
				wscript.echo "Ouput File exits and You not allow to overwrite it:" & vbnewline & outPath
				wscript.quit(-90000)
			else
				Set outFile = fso.CreateTextFile(outPath,True)
			end if
		else
			Set outFile = fso.CreateTextFile(outPath,True)
		end if
		if outFile is nothing then
			wscript.echo "File not found:" & vbnewline & outPath
			wscript.quit(-90001)
		end if
	end if
	if outFile is Nothing then
		'' WScript.Echo WScript.FullName
		i=instrrev(UCase(WScript.FullName), LCase("cscript"))
		if i > 0 then 
			Set StdOut = WScript.StdOut
			StdOut.Write t 
		else
			WScript.echo t
		end if
	else
		outFile.Write t
		outFile.Close	
    end if

end sub

